## Flow

You can create a simple app with the following code:

```Python 
from tensorpc.flow import mui, three, plus, appctx, mark_create_layout, flow
class App:
    class Config(plus.AppInMemory.Config):
        is_horizontal = False
        height = "800px"
    @mark_create_layout
    def my_layout(self):
        selected_sx_props = {
            ".node_selected:only-child": {
                "border": "2px solid red",
            }
        }
        nodes = [
            flow.Node(id="a", data=flow.NodeData(label="hello"), position=flow.XYPosition(0, 0)),
            flow.Node(id="b", type="app", data=flow.NodeData(component=mui.HBox([
                flow.NodeResizer().prop(minWidth=100, minHeight=100, maxWidth=300, maxHeight=300),
                mui.Typography("wtf"),
                mui.Button("Test"),
            ]).prop(width="100%", height="100%", minWidth=100, minHeight=100, border="2px solid black", borderRadius="21px", className="node_selected")), position=flow.XYPosition(300, 0)),
        ]
        return mui.HBox([
            flow.Flow(nodes, [], [
                flow.MiniMap(),
                flow.Controls(),
                flow.Background().prop(variant="lines", color="#efefef"),
            ]).prop(selectedBoxSxProps=selected_sx_props)
        ]).prop(width="100%", height="100%", overflow="hidden")
```

