## Flow

You can create a simple app with the following code:

```Python 
from tensorpc.flow import mui, three, plus, appctx, mark_create_layout, flow
class App:
    
    class Config(plus.AppInMemory.Config):
        is_horizontal = False
        height = "800px"

    @mark_create_layout
    def my_layout(self):
        nodes = [
            flow.Node(id="1", type="input", data=flow.NodeData(label="Input Node"), position=flow.XYPosition(0, 0)),
            flow.Node(id="2", data=flow.NodeData(label="node 2"), position=flow.XYPosition(0, 100)),
            flow.Node(id="2a", data=flow.NodeData(label="node 2a"), position=flow.XYPosition(0, 200)),
            flow.Node(id="2b", data=flow.NodeData(label="node 2b"), position=flow.XYPosition(0, 300)),
            flow.Node(id="2c", data=flow.NodeData(label="node 2c"), position=flow.XYPosition(0, 400)),
            flow.Node(id="2d", data=flow.NodeData(label="node 2d"), position=flow.XYPosition(0, 500)),
            flow.Node(id="3", data=flow.NodeData(label="node 3"), position=flow.XYPosition(200, 100)),

        ]
        edges = [
            flow.Edge("e12", source="1", target="2", animated=True),
            flow.Edge("e13", source="1", target="3", animated=True),
            flow.Edge("e22a", source="2", target="2a", animated=True),
            flow.Edge("e22b", source="2", target="2b", animated=True),
            flow.Edge("e22c", source="2", target="2c", animated=True),
            flow.Edge("e2c2d", source="2c", target="2d", animated=True),
        ]
        graph = flow.Flow(nodes, edges, [
            flow.MiniMap(),
            flow.Controls(),
            flow.Background()
        ])
        return mui.HBox([
            graph,
            mui.HBox([
                mui.Button("LayoutV", lambda: graph.do_dagre_layout(flow.DagreLayoutOptions(rankdir="TB"))),
                mui.Button("LayoutH", lambda: graph.do_dagre_layout(flow.DagreLayoutOptions(rankdir="LR"))),
            ]).prop(position="absolute", top=0, right=0),
        ]).prop(width="100%", height="100%", overflow="hidden", position="relative")
```

