## Flow

You can create a simple app with the following code:

```Python 
from tensorpc.flow import mui, three, plus, appctx, mark_create_layout, flow
class App:
    class Config(plus.AppInMemory.Config):
        is_horizontal = False
        height = "800px"
    @mark_create_layout
    def my_layout(self):
        custom_node_ui = mui.VBox([
            mui.HBox([
                flow.Handle(type="target", position="left", id="0").prop(position="absolute", top="50%"),
                mui.Typography("large handle"),
            ]).prop(flex=2, position="relative", alignItems="center", border="1px solid black"),
            mui.HBox([
                flow.Handle(type="target", position="left", id="1").prop(position="relative", alignSelf="flex-start"),
                mui.Typography("small handle"),

            ]).prop(alignItems="center", border="1px solid black"),
            mui.HBox([
                flow.Handle(type="target", position="left", id="2").prop(position="relative", alignSelf="flex-start"),
                mui.Typography("small handle"),

            ]).prop(alignItems="center", border="1px solid black"),
            mui.HBox([
                flow.Handle(type="target", position="left", id="3").prop(position="relative", alignSelf="flex-start"),
                mui.Typography("small handle"),
            ]).prop(alignItems="center", border="1px solid black"),
        ]).prop(width=300, height=400, backgroundColor="white", border="1px solid black")
        custom_node_ui.update_sx_props({
            ".react-flow__handle": {
                "background": "#bbb",
                "width": "8px",
                "height": "4px",
                "border": "none",
                "borderRadius": "0",
            },
            ".react-flow__handle-left": {
                "height": "8px",
                "width": "4px",
                "left": "-7px",
                "borderRadius": "2px 0 0 2px",
            },

        })
        nodes = [
            flow.Node(id="1-1", type="input", data=flow.NodeData(label="Input Node"), position=flow.XYPosition(0, 0), sourcePosition="right"),

            flow.Node(id="a", type="app", data=flow.NodeData(component=custom_node_ui), position=flow.XYPosition(300, 0)),
        ]
        return mui.HBox([
            flow.Flow(nodes, [], [
                flow.MiniMap(),
                flow.Controls(),
                flow.Background(),
            ]),
        ]).prop(width="100%", height="100%", overflow="hidden")
```

