## Flow

You can create a simple app with the following code:

```Python 
from tensorpc.flow import mui, three, plus, appctx, mark_create_layout, flow
class App:
    class Config(plus.AppInMemory.Config):
        is_horizontal = False
        height = "800px"
    @mark_create_layout
    def my_layout(self):
        custom_node_ui_source_a = mui.VBox([
            mui.Typography("only connectable with handle id prefix PA"),
            flow.Handle("source", "right", id="PA-0")
        ]).prop(width=200,  alignItems="center", backgroundColor="white", border="1px solid black")
        custom_node_ui_source_b = mui.VBox([
            mui.Typography("only connectable with handle id prefix PB"),
            flow.Handle("source", "right", id="PB-wtf")
        ]).prop(width=200,  alignItems="center", backgroundColor="white", border="1px solid black")
        custom_node_ui_tgt_a = mui.VBox([
            mui.Typography("Node handle with PA prefix"),
            flow.Handle("target", "left", id="PA-wtfnode")
        ]).prop(width=200,  alignItems="center", backgroundColor="white", border="1px solid black")
        custom_node_ui_tgt_b = mui.VBox([
            mui.Typography("Node handle with PB prefix"),
            flow.Handle("target", "left", id="PB-wtfnode")
        ]).prop(width=200,  alignItems="center", backgroundColor="white", border="1px solid black")
        custom_node_ui_tgt_c = mui.VBox([
            mui.Typography("Node handle with PC prefix"),
            flow.Handle("target", "left", id="PC-wtfnode")
        ]).prop(width=200,  alignItems="center", backgroundColor="white", border="1px solid black")

        nodes = [
            flow.Node(id="sa", type="app", data=flow.NodeData(component=custom_node_ui_source_a), position=flow.XYPosition(0, 0)),
            flow.Node(id="sb", type="app", data=flow.NodeData(component=custom_node_ui_source_b), position=flow.XYPosition(0, 200)),
            flow.Node(id="ta", type="app", data=flow.NodeData(component=custom_node_ui_tgt_a), position=flow.XYPosition(300, 0)),
            flow.Node(id="tb", type="app", data=flow.NodeData(component=custom_node_ui_tgt_b), position=flow.XYPosition(300, 100)),
            flow.Node(id="tc", type="app", data=flow.NodeData(component=custom_node_ui_tgt_c), position=flow.XYPosition(300, 200)),
        ]
        # undirected conn map
        valid_conn_map = {
            "PA": ["PA"],
            "PB": ["PB"],
            "PC": ["PC"],
        }
        return mui.HBox([
            flow.Flow(nodes, [], [
                flow.MiniMap(),
                flow.Controls(),
                flow.Background(),
            ]).prop(validConnectMap=valid_conn_map),
        ]).prop(width="100%", height="100%", overflow="hidden")
```

